﻿#SingleInstance force
CoordMode, ToolTip, Screen

; 設定ファイル
parameter = %A_ScriptDir%/ini/Parameter.ini

; GUI用の座標
X1 := 20  ;1列目
X2 := 90
X3 := 300
Y1 := 15  ;1行目
Y2 := 55
Y3 := 90
Y4 := 120


; 画像ファイルに関する情報
pic_Stop = %A_ScriptDir%/icon/01_停止.png
pic_Exec = %A_ScriptDir%/icon/02_再生.png
ps := 40 ;Picture Size

; ToolTipに関する情報
; ToolTip表示時の透明度
IniRead, TOOLTIP_TRANSPARENCY, %parameter%, ToolTipSection, TOOLTIP_TRANSPARENCY, 70

AutoExecute:
	;=======================
	; GUIコンポーネントの設定
	;=======================
	; 再生／停止ボタン
	picX := X1 - 5
	picY := Y1 - 5
	Gui, Add, Picture, vstatusPicture x%picX% y%picY%,
	GuiControl,, statusPicture, *w%ps% *h%ps% %pic_Stop%

	; インターバル入力用コンボボックス
	Gui, Add, ComboBox ,x%X2% y%Y1%  w85 gIntervalComboboxFunction vInterval, |1800||600||120|60|30|10|5||3||1|0.5|0.1|
	Gui, Add, UpDown   ,                  gUpDownFunction           vUpDn      Range0.011-10000
	Gui, Add, Text, xp+100 yp+3, 秒間隔で
	; 初期値セット（INIファイルから読込。読めなければ5秒）
	IniRead , defaultIntervalSecond, %parameter%, DefaultIntervalSection, defaultIntervalSecond, 5
	GuiControl, Text, Interval, %defaultIntervalSecond%

	; Sendキー選択リスト（INIファイルから読込。読めなければ「左クリック」）
	IniRead, iniSendKey, %parameter%, SendKeySection, latestSendKey, LButton
	Gui, Add, ComboBox, x%X2%  y%Y2% w120 vSendKey gSendkeyComboboxFunction, %iniSendKey%|||LButton|PgDn|Enter|Space|WheelDown|WheelUp|F5
	Gui, Add, Text, xp+130 yp+3, キーを送る

	; 残り秒数を表示
	Gui, Add, Checkbox, x%X2%  y%Y3% Checked vShowSecondsToolTipFlg gShowRemainingSeconds, 連打中に残り秒数を表示

	; Escで連打停止
	Gui, Add, Checkbox, x%X2%  y%Y4% Checked vStopEscFlg gToggleEscHotkey, Escで連打停止
	Hotkey, ~Esc, StopButton, Toggle

	; 実行ボタン
	Gui, Add, Button, gExecButton x%X3% y%Y1% Default, %A_Space%実行%A_Space%(&A)
	; 停止ボタン
	Gui, Add, Button, gStopButton x%X3% y%Y2%        , %A_Space%停止%A_Space%(&S)
	
	; マウスカーソルの下に画面を表示
	GUIShow(-50,-50)

return


;=====================================
; 各コンポーネントの値変更時に走る処理
;=====================================

; 秒間隔のコンボボックス変更時に走る処理
IntervalComboboxFunction:
	; 画面入力した値をプログラムに反映
	Gui, Submit, Nohide
	; 値をparameter.iniに出力
	IniWrite   , %Interval%, %parameter%, DefaultIntervalSection, defaultIntervalSecond
return
UpDownFunction:
	Gui, Submit, Nohide
	GuiControl , Text, Interval, %Interval%
	IniWrite   , %Interval%, %parameter%, DefaultIntervalSection, defaultIntervalSecond
return

; Sendキーのコンボボックス変更時に走る処理
SendkeyComboboxFunction:
	Gui, Submit, Nohide
	IniWrite   , %SendKey%, %parameter%, SendKeySection, latestSendKey
return

;=======================
; 各ボタン押下時に走る処理
;=======================
; 実行ボタン
ExecButton:
	SetTimer, KeySend     , Off
	SetTimer, WatchCursor , off
	SetTimer, FollowCursor, off
	Gui     , Submit      , NoHide

	If Interval is not number
	{	msgbox, 不正な値です。
		return
	} If ( Interval = NULL || Interval = 0 ) {
		msgbox, 不正な値です。
		return
	}

	; ToolTipに表示するカウントダウン用の変数
	toolTipInterval := Interval
	; ToolTipの透明度
	toolTipTrans := TOOLTIP_TRANSPARENCY
	SetTimer, WatchCursor , 1000
	SetTimer, FollowCursor, 100
	
	; キーを送る用のSetTimerを起動
	intervalMilliSec := Interval * 1000
	SetTimer, KeySend, %intervalMilliSec%
	
	; 再生状態の画像を表示
	GuiControl,, statusPicture, *w%ps% *h%ps% %pic_Exec%

	if ( StopEscFlg = 1 ) {
		toolTipTrans := TOOLTIP_TRANSPARENCY
	}

	; 停止ボタン以外のコンポーネントを触れなくする
	GuiControl, Disable, Interval
	GuiControl, Disable, UpDn
	GuiControl, Disable, SendKey
	GuiControl, Disable, StopEscFlg
	GuiControl, Disable, %A_Space%実行%A_Space%
return

; 指定したキーを送信する
KeySend:
	; キー送信
	Send, {%SendKey%}
	; ToolTipをリセットして再描画
	toolTipInterval := 0
	GoSub, WatchCursor
return

StopButton:
	; キーを送る用のSetTimerを解除
	SetTimer, KeySend , Off

	; 停止状態の画像を表示
	GuiControl,, statusPicture, *w%ps% *h%ps% %pic_Stop%

	toolTipTrans := 0
	ToolTip

	; 使用不可にしていたコンポーネントを使用可能に
	GuiControl, Enable, Interval
	GuiControl, Enable, UpDn
	GuiControl, Enable, SendKey
	GuiControl, Enable, StopEscFlg
	GuiControl, Enable, %A_Space%実行%A_Space%
return


; 1秒に1回、Tooltipのカウンタをデクリメント
WatchCursor:
	toolTipInterval--
	; 0以下になったら、ToolTipのタイマーをリセット
	if ( toolTipInterval <= 0 ) {
		Gui, Submit, NoHide
		toolTipInterval = %Interval%
	}
return

; ツールチップをマウスカーソルに追従
FollowCursor:
	if ( toolTipTrans == 0 ) {
		return
	}
	
	; ToolTipを表示する位置を決定（＝マウスカーソルの位置）
	MouseGetPos, X, Y
	; ツールチップ表示
	ToolTip, %toolTipInterval%, X+15, Y+15
	; 透明度の設定
	WinSet, Trans, %toolTipTrans%, ahk_class tooltips_class32
return

; 「連打中に残り秒数を表示」をON/OFFしたときの処理
ShowRemainingSeconds:
	Gui, Submit, NoHide
	if ( ShowSecondsToolTipFlg = 1 ) {
		toolTipTrans := TOOLTIP_TRANSPARENCY
	} else {
		ToolTip
		toolTipTrans := 0
	}
return

; 「Escで連打停止」をON/OFFしたときの処理
ToggleEscHotkey:
	Gui, Submit, NoHide
	if( StopEscFlg = 1 ) {
		Hotkey, ~Esc, StopButton, Toggle
	} else {
		Hotkey, ~Esc, StopButton, OFF
	}
return


GuiClose:
	ExitApp

GUIShow( xdiff=-50, ydiff=-50, Title="" )
{
	GuiWidth := 385
	GuiHight := 150

	CoordMode  , Mouse, Screen
	MouseGetPos, xpos , ypos
	xpos += %xdiff%
	ypos += %ydiff%
	GUI, Show, X%xpos% Y%ypos% W%GuiWidth% H%GuiHight%, %Title%
}